#ifndef lint
static char const yysccsid[] = "@(#)yaccpar	1.9 (Berkeley) 02/21/93";
#endif
#include <stdlib.h>
#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define YYLEX yylex()
#define YYEMPTY -1
#define yyclearin (yychar=(YYEMPTY))
#define yyerrok (yyerrflag=0)
#define YYRECOVERING (yyerrflag!=0)
#if defined(c_plusplus) || defined(__cplusplus)
#include <stdlib.h>
#else
extern char *getenv();
extern void *realloc();
#endif
static int yygrowstack();
#define YYPREFIX "yy"
#line 2 "../../dev/aic7xxx/aicasm_gram.y"
/*
 * Parser for the Aic7xxx SCSI Host adapter sequencer assembler.
 *
 * Copyright (c) 1997-1998 Justin T. Gibbs.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions, and the following disclaimer,
 *    without modification.
 * 2. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * $FreeBSD: src/sys/dev/aic7xxx/aicasm_gram.y,v 1.8 1999/12/06 18:23:30 gibbs Exp $
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sysexits.h>

#include <sys/types.h>
#include <sys/queue.h>

#include "aicasm.h"
#include "aicasm_symbol.h"
#include "aicasm_insformat.h"

int yylineno;
char *yyfilename;
static symbol_t *cur_symbol;
static symtype cur_symtype;
static symbol_t *accumulator;
static symbol_ref_t allones;
static symbol_ref_t allzeros;
static symbol_ref_t none;
static symbol_ref_t sindex;
static int instruction_ptr;
static int sram_or_scb_offset;
static int download_constant_count;

static void process_bitmask __P((int mask_type, symbol_t *sym, int mask));
static void initialize_symbol __P((symbol_t *symbol));
static void process_register __P((symbol_t **p_symbol));
static void format_1_instr __P((int opcode, symbol_ref_t *dest,
				expression_t *immed, symbol_ref_t *src,
				int ret));
static void format_2_instr __P((int opcode, symbol_ref_t *dest,
				expression_t *places, symbol_ref_t *src,
				int ret));
static void format_3_instr __P((int opcode, symbol_ref_t *src,
				expression_t *immed, symbol_ref_t *address));
static void test_readable_symbol __P((symbol_t *symbol));
static void test_writable_symbol __P((symbol_t *symbol));
static void type_check __P((symbol_t *symbol, expression_t *expression,
			    int and_op));
static void make_expression __P((expression_t *immed, int value));
static void add_conditional __P((symbol_t *symbol));
static int  is_download_const __P((expression_t *immed));

#define YYDEBUG 1
#define SRAM_SYMNAME "SRAM_BASE"
#define SCB_SYMNAME "SCB_BASE"
#line 81 "../../dev/aic7xxx/aicasm_gram.y"
typedef union {
	int		value;
	char		*str;
	symbol_t	*sym;
	symbol_ref_t	sym_ref;
	expression_t	expression;
} YYSTYPE;
#line 108 "y.tab.c"
#define T_REGISTER 257
#define T_CONST 258
#define T_DOWNLOAD 259
#define T_SCB 260
#define T_SRAM 261
#define T_ALIAS 262
#define T_SIZE 263
#define T_ADDRESS 264
#define T_ACCESS_MODE 265
#define T_MODE 266
#define T_BIT 267
#define T_MASK 268
#define T_NUMBER 269
#define T_PATH 270
#define T_CEXPR 271
#define T_EOF 272
#define T_INCLUDE 273
#define T_SHR 274
#define T_SHL 275
#define T_ROR 276
#define T_ROL 277
#define T_MVI 278
#define T_MOV 279
#define T_CLR 280
#define T_BMOV 281
#define T_JMP 282
#define T_JC 283
#define T_JNC 284
#define T_JE 285
#define T_JNE 286
#define T_JNZ 287
#define T_JZ 288
#define T_CALL 289
#define T_ADD 290
#define T_ADC 291
#define T_INC 292
#define T_DEC 293
#define T_STC 294
#define T_CLC 295
#define T_CMP 296
#define T_NOT 297
#define T_XOR 298
#define T_TEST 299
#define T_AND 300
#define T_OR 301
#define T_RET 302
#define T_NOP 303
#define T_ACCUM 304
#define T_ALLONES 305
#define T_ALLZEROS 306
#define T_NONE 307
#define T_SINDEX 308
#define T_A 309
#define T_SYMBOL 310
#define T_NL 311
#define T_IF 312
#define T_ELSE 313
#define T_ELSE_IF 314
#define T_ENDIF 315
#define UMINUS 316
#define YYERRCODE 256
const short yylhs[] = {                                        -1,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   16,   16,   25,   17,
   27,   24,   26,   26,   28,   28,   28,   28,   28,   28,
   28,   28,   28,   28,   28,   29,   30,   31,   32,   33,
   34,   35,   36,   37,   38,   39,    6,    6,    6,    6,
    6,    6,    6,    6,    6,   18,   18,   15,   15,   40,
   42,   19,   43,   44,   20,   41,   41,    1,    1,    1,
    1,    3,    7,    8,    8,    4,    5,    5,    9,    9,
   21,    2,    2,    2,    2,    2,    2,   22,   22,   22,
   22,   10,   10,   10,   10,   23,   23,   23,   23,   23,
   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
   11,   11,   11,   11,   23,   12,   12,   12,   12,   13,
   13,   14,   14,   23,   23,   23,   23,   23,   23,
};
const short yylen[] = {                                         2,
    1,    2,    1,    2,    1,    2,    1,    2,    1,    2,
    1,    2,    1,    2,    1,    2,    4,    4,    0,    3,
    0,    5,    1,    2,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    2,    2,    2,    3,    3,
    2,    1,    1,    1,    1,    1,    3,    3,    3,    3,
    3,    2,    2,    1,    1,    3,    3,    1,    2,    0,
    0,    7,    0,    0,    7,    1,    2,    1,    4,    4,
    1,    1,    1,    1,    1,    1,    0,    2,    0,    1,
    2,    1,    3,    3,    1,    3,    3,    3,    4,    2,
    1,    1,    1,    1,    1,    7,    7,    5,    5,    3,
    7,    3,    4,    8,    6,    6,    5,    4,    3,    2,
    1,    1,    1,    1,    7,    1,    1,    1,    1,    1,
    1,    1,    1,    3,    7,    7,    7,    5,    5,
};
const short yydefred[] = {                                      0,
   19,    0,    0,    0,    0,  112,  111,  114,  113,    0,
    0,    0,    0,  116,  117,  118,  119,   94,   95,    0,
    0,    0,    0,    0,    0,   93,    0,   92,    0,    0,
    0,    0,    0,    0,   91,    0,    0,    0,    0,    1,
    3,    5,    7,    9,   11,   13,   15,    0,    0,   63,
   60,    0,    0,   54,   71,    0,    0,    0,    0,   72,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   80,    0,    0,    0,    0,   76,    0,    0,    0,
    0,  110,    0,   81,    0,    0,   90,    2,    4,    6,
    8,   10,   12,   14,   16,    0,    0,    0,    0,    0,
    0,   20,   57,   58,    0,   56,    0,    0,    0,    0,
    0,   55,   53,   52,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  102,
    0,  100,    0,    0,    0,    0,  109,   88,    0,    0,
    0,    0,    0,    0,    0,  124,   21,   59,    0,   64,
   61,   17,   18,    0,    0,   51,   75,    0,    0,    0,
    0,   49,   50,    0,    0,    0,  108,    0,   78,    0,
    0,  103,    0,    0,    0,    0,    0,    0,    0,   89,
    0,    0,   83,   84,   86,   87,    0,   36,    0,    0,
   70,   69,    0,  129,    0,  128,    0,   98,   99,    0,
  122,  123,    0,  107,  121,  120,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   42,   43,   44,   45,
   46,    0,   23,   25,   26,   27,   28,   29,   30,   31,
   32,   33,   34,   35,   66,    0,    0,  106,  105,    0,
    0,    0,    0,    0,    0,    0,    0,   41,   37,   38,
    0,    0,   22,   24,   65,   67,   62,    0,  101,  127,
  126,  125,   97,   96,  115,   39,    0,  104,
};
const short yydgoto[] = {                                      36,
   60,  100,   61,   67,  127,  158,   63,  159,   74,   37,
   38,   39,  207,  203,  106,   40,   41,   42,   43,   44,
   45,   46,   47,  235,   48,  222,  187,  223,  224,  225,
  226,  227,  228,  229,  230,  231,  232,  233,  234,  108,
  236,  190,  107,  189,
};
const short yysindex[] = {                                     68,
    0, -276,  -86,  -78,   -4,    0,    0,    0,    0,  -36,
 -230, -230, -230,    0,    0,    0,    0,    0,    0, -230,
 -230, -263, -252, -230, -230,    0, -230,    0, -230,  -17,
 -253,   -5, -213, -110,    0,   68, -230, -230,  -45,    0,
    0,    0,    0,    0,    0,    0,    0, -249,  -37,    0,
    0, -197, -185,    0,    0,   -2,  -35,  -35,  -35,    0,
   62,   60, -201,   -2,    0,   75, -201, -253,   79,   86,
   86,    0, -253,   52, -230,   73,    0,  100,   86,  104,
  105,    0,   93,    0,   32, -150,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  114,  115,   19,   59,  101,
   38,    0,    0,    0, -106,    0,  -99,  -99,  102,  132,
 -233,    0,    0,    0,   33,  -33,  -35,  -35,  -35,  -35,
  -45, -230,  -45,  108, -230, -230, -253, -253,  109,    0,
  129,    0,  -33, -253,  -33,  -33,    0,    0,   53,  -33,
  -35,  -92,  -91,  -88,  -87,    0,    0,    0,  -84,    0,
    0,    0,    0,   90,   94,    0,    0,   60, -253,   77,
   67,    0,    0,  120, -253,  127,    0,  144,    0,  130,
  133,    0,  -33, -190,  136, -153,   60, -201,   86,    0,
   86,   56,    0,    0,    0,    0,  135,    0, -249, -249,
    0,    0,  137,    0,  139,    0,  -33,    0,    0, -253,
    0,    0,  -45,    0,    0,    0,  -45,  -45, -253, -253,
 -253, -111,  -69,  -65, -107, -105,    0,    0,    0,    0,
    0,  -93,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, -101, -100,    0,    0, -253,
  145,  157,  158,  159,  160,  161,  162,    0,    0,    0,
  -41,  -35,    0,    0,    0,    0,    0,  164,    0,    0,
    0,    0,    0,    0,    0,    0,   60,    0,
};
const short yyrindex[] = {                                      0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  172,  172,    0,    0,    0,    0,    0,    0,    0,
  172,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  -27,    0,    0,    0,    0,
    0, -175,    0,  -30,   28,    0,    0,  172,    0,  -44,
  -44,    0,  172,    0,    0,    0,    0,    0,  -44,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  -17,  176,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  172,  172,    0,    0,
    0,    0,    0,  172,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    4,  172,   16,
  -38,    0,    0,    0,  172,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   25,    0,  -44,    0,
  -44,  -44,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  172,
    0,    0,    0,    0,    0,    0,    0,    0,  172,  172,
  172,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  172,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   69,    0,
};
const short yygindex[] = {                                      0,
   11,  -90,  371,   17,  -28,    9,  103,  -81,   -3,    0,
    0,  -40,    0,    0,    0,  202,  204,  205,  206,  207,
  224,  227,  235,  -46,    0,    0,    0,   63,   39,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   92,    0,    0,    0,
};
#define YYTABLESIZE 446
const short yytable[] = {                                      48,
   99,  102,   48,   59,   59,   48,   59,  105,   57,   57,
   55,   57,   87,   68,   77,   55,   68,   55,   62,   76,
   48,   65,  121,  255,  257,   75,  123,   83,   68,   53,
  164,  253,  166,   49,   77,  154,   50,   77,   72,   81,
   78,   82,  128,   80,   51,   55,   64,   74,   72,   72,
  134,  174,   84,  176,  179,   52,   47,   85,  181,   47,
  101,  142,   74,  143,  124,  113,  114,  115,   74,  129,
  118,   72,  109,  156,   47,  119,  155,  120,   55,   64,
   14,   15,   16,   74,  110,   48,   48,   17,  111,   58,
   58,  200,   58,  118,  201,  202,   55,  118,  119,  126,
  120,  144,  119,  145,  120,  116,   73,   73,   73,  119,
  130,  120,  242,   73,  118,  240,  243,  244,  122,  119,
  139,  120,  125,  170,  171,  160,  161,  162,  163,  126,
  175,  132,   77,  205,  206,   77,   77,  208,  165,   47,
   47,  168,  169,  133,  177,  150,  151,  135,  136,  182,
  209,  137,  210,  211,  138,  193,  117,  140,  141,  146,
  147,  195,  148,  152,  149,  153,  167,  172,  212,  213,
  149,  214,  173,  215,  216,  180,  183,  184,  194,  117,
  185,  186,  191,  117,  188,  196,  192,  197,  198,  256,
  256,  199,   35,   40,  204,  238,  241,  239,  248,  249,
  250,   86,  251,  259,  252,  245,  246,  247,  101,  101,
  217,  218,  219,  220,  221,  260,  261,  262,  263,  264,
  265,  103,  268,   48,   48,   48,   48,  266,   48,   48,
   79,  104,   54,   54,   85,   54,  258,   88,  178,   89,
   90,   91,   92,   48,   48,   48,   48,   48,   48,   48,
   48,   68,   68,   68,   55,   55,   55,   77,   68,   93,
  267,   55,   94,   48,   98,   48,   48,   48,   48,   48,
   95,   68,   55,   56,  112,  157,  112,   47,   47,   47,
   47,  237,   47,   47,  254,    0,    0,    0,   74,   74,
   74,   74,    0,    0,    0,    0,    0,   47,   47,   47,
   47,   47,   47,   47,   47,   74,   73,   73,   73,   76,
   76,   76,    0,   73,    0,    0,   76,   47,    0,   47,
   47,   47,   47,   47,    1,    2,   74,    3,    4,    0,
   40,   40,   40,   40,    0,   40,   40,    0,    0,    0,
    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,
   15,   16,    0,    0,    0,    0,   17,   18,   19,   20,
   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,
   31,    0,   40,   40,   40,   40,   40,   32,    0,   33,
   34,   66,   68,   69,    0,    0,    0,    0,    0,    0,
   70,   71,   73,    0,    0,   79,  212,  213,  149,  214,
    0,  215,  216,    0,    0,    0,    0,   96,   97,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  217,  218,
  219,  220,  221,    0,    0,  131,
};
const short yycheck[] = {                                      38,
   46,   48,   41,   40,   40,   44,   40,   45,   45,   45,
   38,   45,  123,   44,   59,   43,   44,   45,   10,   23,
   59,   11,   63,  125,  125,  278,   67,   31,   59,   34,
  121,  125,  123,  310,   24,  269,  123,   27,  302,   29,
   24,   59,   71,   27,  123,  309,  310,   44,  302,  302,
   79,  133,   58,  135,  136,   60,   41,  271,  140,   44,
  310,   43,   59,   45,   68,   57,   58,   59,   44,   73,
   38,   44,  270,   41,   59,   43,  310,   45,  309,  310,
  282,  283,  284,   59,  270,  124,  125,  289,   91,  126,
  126,  173,  126,   38,  285,  286,  124,   38,   43,   44,
   45,   43,   43,   45,   45,   44,  282,  283,  284,   43,
   59,   45,  203,  289,   38,  197,  207,  208,   44,   43,
  271,   45,   44,  127,  128,  117,  118,  119,  120,   44,
  134,   59,  122,  287,  288,  125,  126,  178,  122,  124,
  125,  125,  126,   44,  136,  107,  108,   44,   44,  141,
  179,   59,  181,  182,  123,  159,  124,   44,   44,   59,
  123,  165,  269,   62,  264,   34,   59,   59,  262,  263,
  264,  265,   44,  267,  268,  123,  269,  269,   59,  124,
  269,  269,   93,  124,  269,   59,   93,   44,   59,  236,
  237,   59,  125,  125,   59,   59,  200,   59,  310,  269,
  266,  312,  310,   59,  310,  209,  210,  211,  310,  310,
  304,  305,  306,  307,  308,   59,   59,   59,   59,   59,
   59,  259,   59,  262,  263,  264,  265,  269,  267,  268,
   59,  269,  269,  269,   59,  269,  240,   36,  136,   36,
   36,   36,   36,  282,  283,  284,  285,  286,  287,  288,
  289,  282,  283,  284,  282,  283,  284,  302,  289,   36,
  252,  289,   36,  302,  310,  304,  305,  306,  307,  308,
   36,  302,  309,  310,  310,  309,  310,  262,  263,  264,
  265,  190,  267,  268,  222,   -1,   -1,   -1,  285,  286,
  287,  288,   -1,   -1,   -1,   -1,   -1,  282,  283,  284,
  285,  286,  287,  288,  289,  302,  282,  283,  284,  282,
  283,  284,   -1,  289,   -1,   -1,  289,  302,   -1,  304,
  305,  306,  307,  308,  257,  258,  302,  260,  261,   -1,
  262,  263,  264,  265,   -1,  267,  268,   -1,   -1,   -1,
  273,  274,  275,  276,  277,  278,  279,  280,  281,  282,
  283,  284,   -1,   -1,   -1,   -1,  289,  290,  291,  292,
  293,  294,  295,  296,  297,  298,  299,  300,  301,  302,
  303,   -1,  304,  305,  306,  307,  308,  310,   -1,  312,
  313,   11,   12,   13,   -1,   -1,   -1,   -1,   -1,   -1,
   20,   21,   22,   -1,   -1,   25,  262,  263,  264,  265,
   -1,  267,  268,   -1,   -1,   -1,   -1,   37,   38,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  304,  305,
  306,  307,  308,   -1,   -1,   75,
};
#define YYFINAL 36
#ifndef YYDEBUG
#define YYDEBUG 0
#elif YYDEBUG
#include <stdio.h>
#endif
#define YYMAXTOKEN 316
#if YYDEBUG
const char * const yyname[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
"'\"'",0,0,0,"'&'",0,"'('","')'",0,"'+'","','","'-'","'.'",0,0,0,0,0,0,0,0,0,0,
0,"':'","';'","'<'",0,"'>'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,"'['",0,"']'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
"'{'","'|'","'}'","'~'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"T_REGISTER","T_CONST","T_DOWNLOAD",
"T_SCB","T_SRAM","T_ALIAS","T_SIZE","T_ADDRESS","T_ACCESS_MODE","T_MODE",
"T_BIT","T_MASK","T_NUMBER","T_PATH","T_CEXPR","T_EOF","T_INCLUDE","T_SHR",
"T_SHL","T_ROR","T_ROL","T_MVI","T_MOV","T_CLR","T_BMOV","T_JMP","T_JC","T_JNC",
"T_JE","T_JNE","T_JNZ","T_JZ","T_CALL","T_ADD","T_ADC","T_INC","T_DEC","T_STC",
"T_CLC","T_CMP","T_NOT","T_XOR","T_TEST","T_AND","T_OR","T_RET","T_NOP",
"T_ACCUM","T_ALLONES","T_ALLZEROS","T_NONE","T_SINDEX","T_A","T_SYMBOL","T_NL",
"T_IF","T_ELSE","T_ELSE_IF","T_ENDIF","UMINUS",
};
const char * const yyrule[] = {
"$accept : program",
"program : include",
"program : program include",
"program : register",
"program : program register",
"program : constant",
"program : program constant",
"program : scratch_ram",
"program : program scratch_ram",
"program : scb",
"program : program scb",
"program : label",
"program : program label",
"program : conditional",
"program : program conditional",
"program : code",
"program : program code",
"include : T_INCLUDE '<' T_PATH '>'",
"include : T_INCLUDE '\"' T_PATH '\"'",
"$$1 :",
"register : T_REGISTER $$1 reg_definition",
"$$2 :",
"reg_definition : T_SYMBOL '{' $$2 reg_attribute_list '}'",
"reg_attribute_list : reg_attribute",
"reg_attribute_list : reg_attribute_list reg_attribute",
"reg_attribute : reg_address",
"reg_attribute : size",
"reg_attribute : access_mode",
"reg_attribute : bit_defn",
"reg_attribute : mask_defn",
"reg_attribute : alias",
"reg_attribute : accumulator",
"reg_attribute : allones",
"reg_attribute : allzeros",
"reg_attribute : none",
"reg_attribute : sindex",
"reg_address : T_ADDRESS T_NUMBER",
"size : T_SIZE T_NUMBER",
"access_mode : T_ACCESS_MODE T_MODE",
"bit_defn : T_BIT T_SYMBOL T_NUMBER",
"mask_defn : T_MASK T_SYMBOL expression",
"alias : T_ALIAS T_SYMBOL",
"accumulator : T_ACCUM",
"allones : T_ALLONES",
"allzeros : T_ALLZEROS",
"none : T_NONE",
"sindex : T_SINDEX",
"expression : expression '|' expression",
"expression : expression '&' expression",
"expression : expression '+' expression",
"expression : expression '-' expression",
"expression : '(' expression ')'",
"expression : '~' expression",
"expression : '-' expression",
"expression : T_NUMBER",
"expression : T_SYMBOL",
"constant : T_CONST T_SYMBOL numerical_value",
"constant : T_CONST T_SYMBOL T_DOWNLOAD",
"numerical_value : T_NUMBER",
"numerical_value : '-' T_NUMBER",
"$$3 :",
"$$4 :",
"scratch_ram : T_SRAM '{' $$3 reg_address $$4 scb_or_sram_reg_list '}'",
"$$5 :",
"$$6 :",
"scb : T_SCB '{' $$5 reg_address $$6 scb_or_sram_reg_list '}'",
"scb_or_sram_reg_list : reg_definition",
"scb_or_sram_reg_list : scb_or_sram_reg_list reg_definition",
"reg_symbol : T_SYMBOL",
"reg_symbol : T_SYMBOL '[' T_SYMBOL ']'",
"reg_symbol : T_SYMBOL '[' T_NUMBER ']'",
"reg_symbol : T_A",
"destination : reg_symbol",
"immediate : expression",
"immediate_or_a : expression",
"immediate_or_a : T_A",
"source : reg_symbol",
"opt_source :",
"opt_source : ',' source",
"ret :",
"ret : T_RET",
"label : T_SYMBOL ':'",
"address : T_SYMBOL",
"address : T_SYMBOL '+' T_NUMBER",
"address : T_SYMBOL '-' T_NUMBER",
"address : '.'",
"address : '.' '+' T_NUMBER",
"address : '.' '-' T_NUMBER",
"conditional : T_IF T_CEXPR '{'",
"conditional : T_ELSE T_IF T_CEXPR '{'",
"conditional : T_ELSE '{'",
"conditional : '}'",
"f1_opcode : T_AND",
"f1_opcode : T_XOR",
"f1_opcode : T_ADD",
"f1_opcode : T_ADC",
"code : f1_opcode destination ',' immediate_or_a opt_source ret ';'",
"code : T_OR reg_symbol ',' immediate_or_a opt_source ret ';'",
"code : T_INC destination opt_source ret ';'",
"code : T_DEC destination opt_source ret ';'",
"code : T_CLC ret ';'",
"code : T_CLC T_MVI destination ',' immediate_or_a ret ';'",
"code : T_STC ret ';'",
"code : T_STC destination ret ';'",
"code : T_BMOV destination ',' source ',' immediate_or_a ret ';'",
"code : T_MOV destination ',' source ret ';'",
"code : T_MVI destination ',' immediate_or_a ret ';'",
"code : T_NOT destination opt_source ret ';'",
"code : T_CLR destination ret ';'",
"code : T_NOP ret ';'",
"code : T_RET ';'",
"f2_opcode : T_SHL",
"f2_opcode : T_SHR",
"f2_opcode : T_ROL",
"f2_opcode : T_ROR",
"code : f2_opcode destination ',' expression opt_source ret ';'",
"jmp_jc_jnc_call : T_JMP",
"jmp_jc_jnc_call : T_JC",
"jmp_jc_jnc_call : T_JNC",
"jmp_jc_jnc_call : T_CALL",
"jz_jnz : T_JZ",
"jz_jnz : T_JNZ",
"je_jne : T_JE",
"je_jne : T_JNE",
"code : jmp_jc_jnc_call address ';'",
"code : T_OR reg_symbol ',' immediate jmp_jc_jnc_call address ';'",
"code : T_TEST source ',' immediate_or_a jz_jnz address ';'",
"code : T_CMP source ',' immediate_or_a je_jne address ';'",
"code : T_MOV source jmp_jc_jnc_call address ';'",
"code : T_MVI immediate jmp_jc_jnc_call address ';'",
};
#endif
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 10000
#define YYMAXDEPTH 10000
#endif
#endif
#define YYINITSTACKSIZE 200
int yydebug;
int yynerrs;
int yyerrflag;
int yychar;
short *yyssp;
YYSTYPE *yyvsp;
YYSTYPE yyval;
YYSTYPE yylval;
short *yyss;
short *yysslim;
YYSTYPE *yyvs;
int yystacksize;
#line 997 "../../dev/aic7xxx/aicasm_gram.y"

static void
process_bitmask(mask_type, sym, mask)
	int		mask_type;
	symbol_t	*sym;
	int		mask;
{
	/*
	 * Add the current register to its
	 * symbol list, if it already exists,
	 * warn if we are setting it to a
	 * different value, or in the bit to
	 * the "allowed bits" of this register.
	 */
	if (sym->type == UNINITIALIZED) {
		sym->type = mask_type;
		initialize_symbol(sym);
		if (mask_type == BIT) {
			if (mask == 0) {
				stop("Bitmask with no bits set", EX_DATAERR);
				/* NOTREACHED */
			}
			if ((mask & ~(0x01 << (ffs(mask) - 1))) != 0) {
				stop("Bitmask with more than one bit set",
				     EX_DATAERR);
				/* NOTREACHED */
			}
		}
		sym->info.minfo->mask = mask;
	} else if (sym->type != mask_type) {
		stop("Bit definition mirrors a definition of the same "
		     " name, but a different type", EX_DATAERR);
		/* NOTREACHED */
	} else if (mask != sym->info.minfo->mask) {
		stop("Bitmask redefined with a conflicting value", EX_DATAERR);
		/* NOTREACHED */
	}
	/* Fail if this symbol is already listed */
	if (symlist_search(&(sym->info.minfo->symrefs),
			   cur_symbol->name) != NULL) {
		stop("Bitmask defined multiple times for register", EX_DATAERR);
		/* NOTREACHED */
	}
	symlist_add(&(sym->info.minfo->symrefs), cur_symbol,
		    SYMLIST_INSERT_HEAD);
	cur_symbol->info.rinfo->valid_bitmask |= mask;
	cur_symbol->info.rinfo->typecheck_masks = TRUE;
}

static void
initialize_symbol(symbol)
	symbol_t *symbol;
{
	switch (symbol->type) {
        case UNINITIALIZED:
		stop("Call to initialize_symbol with type field unset",
		     EX_SOFTWARE);
		/* NOTREACHED */
		break;
        case REGISTER:
        case SRAMLOC:
        case SCBLOC:
		symbol->info.rinfo =
		    (struct reg_info *)malloc(sizeof(struct reg_info));
		if (symbol->info.rinfo == NULL) {
			stop("Can't create register info", EX_SOFTWARE);
			/* NOTREACHED */
		}
		memset(symbol->info.rinfo, 0,
		       sizeof(struct reg_info));
		break;
        case ALIAS:
		symbol->info.ainfo =
		    (struct alias_info *)malloc(sizeof(struct alias_info));
		if (symbol->info.ainfo == NULL) {
			stop("Can't create alias info", EX_SOFTWARE);
			/* NOTREACHED */
		}
		memset(symbol->info.ainfo, 0,
		       sizeof(struct alias_info));
		break;
        case MASK:
        case BIT:
		symbol->info.minfo =
		    (struct mask_info *)malloc(sizeof(struct mask_info));
		if (symbol->info.minfo == NULL) {
			stop("Can't create bitmask info", EX_SOFTWARE);
			/* NOTREACHED */
		}
		memset(symbol->info.minfo, 0, sizeof(struct mask_info));
		SLIST_INIT(&(symbol->info.minfo->symrefs));
		break;
        case CONST:
        case DOWNLOAD_CONST:
		symbol->info.cinfo =
		    (struct const_info *)malloc(sizeof(struct const_info));
		if (symbol->info.cinfo == NULL) {
			stop("Can't create alias info", EX_SOFTWARE);
			/* NOTREACHED */
		}
		memset(symbol->info.cinfo, 0,
		       sizeof(struct const_info));
		break;
	case LABEL:
		symbol->info.linfo =
		    (struct label_info *)malloc(sizeof(struct label_info));
		if (symbol->info.linfo == NULL) {
			stop("Can't create label info", EX_SOFTWARE);
			/* NOTREACHED */
		}
		memset(symbol->info.linfo, 0,
		       sizeof(struct label_info));
		break;
	case CONDITIONAL:
		symbol->info.condinfo =
		    (struct cond_info *)malloc(sizeof(struct cond_info));
		if (symbol->info.condinfo == NULL) {
			stop("Can't create conditional info", EX_SOFTWARE);
			/* NOTREACHED */
		}
		memset(symbol->info.condinfo, 0,
		       sizeof(struct cond_info));
		break;
	default:
		stop("Call to initialize_symbol with invalid symbol type",
		     EX_SOFTWARE);
		/* NOTREACHED */
		break;
	}
}

static void
process_register(p_symbol)
	symbol_t **p_symbol;
{
	char buf[255];
	symbol_t *symbol = *p_symbol;

	if (symbol->type == UNINITIALIZED) {
		snprintf(buf, sizeof(buf), "Undefined register %s",
			 symbol->name);
		stop(buf, EX_DATAERR);
		/* NOTREACHED */
	} else if (symbol->type == ALIAS) {
		*p_symbol = symbol->info.ainfo->parent;
	} else if ((symbol->type != REGISTER)
		&& (symbol->type != SCBLOC)
		&& (symbol->type != SRAMLOC)) {
		snprintf(buf, sizeof(buf),
			 "Specified symbol %s is not a register",
			 symbol->name);
		stop(buf, EX_DATAERR);
	}
}

static void
format_1_instr(opcode, dest, immed, src, ret)
	int	     opcode;
	symbol_ref_t *dest;
	expression_t *immed;
	symbol_ref_t *src;
	int	     ret;
{
	struct instruction *instr;
	struct ins_format1 *f1_instr;

	if (src->symbol == NULL)
		src = dest;

	/* Test register permissions */
	test_writable_symbol(dest->symbol);
	test_readable_symbol(src->symbol);

	/* Ensure that immediate makes sense for this destination */
	type_check(dest->symbol, immed, opcode);

	/* Allocate sequencer space for the instruction and fill it out */
	instr = seq_alloc();
	f1_instr = &instr->format.format1;
	f1_instr->ret = ret ? 1 : 0;
	f1_instr->opcode = opcode;
	f1_instr->destination = dest->symbol->info.rinfo->address
			      + dest->offset;
	f1_instr->source = src->symbol->info.rinfo->address
			 + src->offset;
	f1_instr->immediate = immed->value;

	if (is_download_const(immed))
		f1_instr->parity = 1;

	symlist_free(&immed->referenced_syms);
	instruction_ptr++;
}

static void
format_2_instr(opcode, dest, places, src, ret)
	int	     opcode;
	symbol_ref_t *dest;
	expression_t *places;
	symbol_ref_t *src;
	int	     ret;
{
	struct instruction *instr;
	struct ins_format2 *f2_instr;
	u_int8_t shift_control;

	if (src->symbol == NULL)
		src = dest;

	/* Test register permissions */
	test_writable_symbol(dest->symbol);
	test_readable_symbol(src->symbol);

	/* Allocate sequencer space for the instruction and fill it out */
	instr = seq_alloc();
	f2_instr = &instr->format.format2;
	f2_instr->ret = ret ? 1 : 0;
	f2_instr->opcode = AIC_OP_ROL;
	f2_instr->destination = dest->symbol->info.rinfo->address
			      + dest->offset;
	f2_instr->source = src->symbol->info.rinfo->address
			 + src->offset;
	if (places->value > 8 || places->value <= 0) {
		stop("illegal shift value", EX_DATAERR);
		/* NOTREACHED */
	}
	switch (opcode) {
	case AIC_OP_SHL:
		if (places->value == 8)
			shift_control = 0xf0;
		else
			shift_control = (places->value << 4) | places->value;
		break;
	case AIC_OP_SHR:
		if (places->value == 8) {
			shift_control = 0xf8;
		} else {
			shift_control = (places->value << 4)
				      | (8 - places->value)
				      | 0x08;
		}
		break;
	case AIC_OP_ROL:
		shift_control = places->value & 0x7;
		break;
	case AIC_OP_ROR:
		shift_control = (8 - places->value) | 0x08;
		break;
	default:
		shift_control = 0; /* Quiet Compiler */
		stop("Invalid shift operation specified", EX_SOFTWARE);
		/* NOTREACHED */
		break;
	};
	f2_instr->shift_control = shift_control;
	symlist_free(&places->referenced_syms);
	instruction_ptr++;
}

static void
format_3_instr(opcode, src, immed, address)
	int	     opcode;
	symbol_ref_t *src;
	expression_t *immed;
	symbol_ref_t *address;
{
	struct instruction *instr;
	struct ins_format3 *f3_instr;
	int addr;

	/* Test register permissions */
	test_readable_symbol(src->symbol);

	/* Ensure that immediate makes sense for this source */
	type_check(src->symbol, immed, opcode);

	/* Allocate sequencer space for the instruction and fill it out */
	instr = seq_alloc();
	f3_instr = &instr->format.format3;
	if (address->symbol == NULL) {
		/* 'dot' referrence.  Use the current instruction pointer */
		addr = instruction_ptr + address->offset;
	} else if (address->symbol->type == UNINITIALIZED) {
		/* forward reference */
		addr = address->offset;
		instr->patch_label = address->symbol;
	} else
		addr = address->symbol->info.linfo->address + address->offset;
	f3_instr->opcode = opcode;
	f3_instr->address = addr;
	f3_instr->source = src->symbol->info.rinfo->address
			 + src->offset;
	f3_instr->immediate = immed->value;

	if (is_download_const(immed))
		f3_instr->parity = 1;

	symlist_free(&immed->referenced_syms);
	instruction_ptr++;
}

static void
test_readable_symbol(symbol)
	symbol_t *symbol;
{
	if (symbol->info.rinfo->mode == WO) {
		stop("Write Only register specified as source",
		     EX_DATAERR);
		/* NOTREACHED */
	}
}

static void
test_writable_symbol(symbol)
	symbol_t *symbol;
{
	if (symbol->info.rinfo->mode == RO) {
		stop("Read Only register specified as destination",
		     EX_DATAERR);
		/* NOTREACHED */
	}
}

static void
type_check(symbol, expression, opcode)
	symbol_t     *symbol;
	expression_t *expression;
	int	     opcode;
{
	symbol_node_t *node;
	int and_op;
	char buf[255];

	and_op = FALSE;
	if (opcode == AIC_OP_AND || opcode == AIC_OP_JNZ || AIC_OP_JZ)
		and_op = TRUE;

	/*
	 * Make sure that we aren't attempting to write something
	 * that hasn't been defined.  If this is an and operation,
	 * this is a mask, so "undefined" bits are okay.
	 */
	if (and_op == FALSE
	 && (expression->value & ~symbol->info.rinfo->valid_bitmask) != 0) {
		snprintf(buf, sizeof(buf),
			 "Invalid bit(s) 0x%x in immediate written to %s",
			 expression->value & ~symbol->info.rinfo->valid_bitmask,
			 symbol->name);
		stop(buf, EX_DATAERR);
		/* NOTREACHED */
	}

	/*
	 * Now make sure that all of the symbols referenced by the
	 * expression are defined for this register.
	 */
	if(symbol->info.rinfo->typecheck_masks != FALSE) {
		for(node = expression->referenced_syms.slh_first;
		    node != NULL;
		    node = node->links.sle_next) {
			if ((node->symbol->type == MASK
			  || node->symbol->type == BIT)
			 && symlist_search(&node->symbol->info.minfo->symrefs,
					   symbol->name) == NULL) {
				snprintf(buf, sizeof(buf),
					 "Invalid bit or mask %s "
					 "for register %s",
					 node->symbol->name, symbol->name);
				stop(buf, EX_DATAERR);
				/* NOTREACHED */
			}
		}
	}
}

static void
make_expression(immed, value)
	expression_t *immed;
	int	     value;
{
	SLIST_INIT(&immed->referenced_syms);
	immed->value = value & 0xff;
}

static void
add_conditional(symbol)
	symbol_t *symbol;
{
	static int numfuncs;

	if (numfuncs == 0) {
		/* add a special conditional, "0" */
		symbol_t *false_func;

		false_func = symtable_get("0");
		if (false_func->type != UNINITIALIZED) {
			stop("Conditional expression '0' "
			     "conflicts with a symbol", EX_DATAERR);
			/* NOTREACHED */
		}
		false_func->type = CONDITIONAL;
		initialize_symbol(false_func);
		false_func->info.condinfo->func_num = numfuncs++;
		symlist_add(&patch_functions, false_func, SYMLIST_INSERT_HEAD);
	}

	/* This condition has occurred before */
	if (symbol->type == CONDITIONAL)
		return;

	if (symbol->type != UNINITIALIZED) {
		stop("Conditional expression conflicts with a symbol",
		     EX_DATAERR);
		/* NOTREACHED */
	}

	symbol->type = CONDITIONAL;
	initialize_symbol(symbol);
	symbol->info.condinfo->func_num = numfuncs++;
	symlist_add(&patch_functions, symbol, SYMLIST_INSERT_HEAD);
}

void
yyerror(string)
	const char *string;
{
	stop(string, EX_DATAERR);
}

static int
is_download_const(immed)
	expression_t *immed;
{
	if ((immed->referenced_syms.slh_first != NULL)
	 && (immed->referenced_syms.slh_first->symbol->type == DOWNLOAD_CONST))
		return (TRUE);

	return (FALSE);
}
#line 1016 "y.tab.c"
/* allocate initial stack or double stack size, up to YYMAXDEPTH */
static int yygrowstack()
{
    int newsize, i;
    short *newss;
    YYSTYPE *newvs;

    if ((newsize = yystacksize) == 0)
        newsize = YYINITSTACKSIZE;
    else if (newsize >= YYMAXDEPTH)
        return -1;
    else if ((newsize *= 2) > YYMAXDEPTH)
        newsize = YYMAXDEPTH;
    i = yyssp - yyss;
    if ((newss = (short *)realloc(yyss, newsize * sizeof *newss)) == NULL)
        return -1;
    yyss = newss;
    yyssp = newss + i;
    if ((newvs = (YYSTYPE *)realloc(yyvs, newsize * sizeof *newvs)) == NULL)
        return -1;
    yyvs = newvs;
    yyvsp = newvs + i;
    yystacksize = newsize;
    yysslim = yyss + newsize - 1;
    return 0;
}

#define YYABORT goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR goto yyerrlab

int
yyparse()
{
    register int yym, yyn, yystate;
#if YYDEBUG
    register const char *yys;

    if ((yys = getenv("YYDEBUG")))
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = (-1);

    if (yyss == NULL && yygrowstack()) goto yyoverflow;
    yyssp = yyss;
    yyvsp = yyvs;
    *yyssp = yystate = 0;

yyloop:
    if ((yyn = yydefred[yystate])) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, yystate, yytable[yyn]);
#endif
        if (yyssp >= yysslim && yygrowstack())
        {
            goto yyoverflow;
        }
        *++yyssp = yystate = yytable[yyn];
        *++yyvsp = yylval;
        yychar = (-1);
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;
#if defined(lint) || defined(__GNUC__)
    goto yynewerror;
#endif
yynewerror:
    yyerror("syntax error");
#if defined(lint) || defined(__GNUC__)
    goto yyerrlab;
#endif
yyerrlab:
    ++yynerrs;
yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yyssp]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *yyssp, yytable[yyn]);
#endif
                if (yyssp >= yysslim && yygrowstack())
                {
                    goto yyoverflow;
                }
                *++yyssp = yystate = yytable[yyn];
                *++yyvsp = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *yyssp);
#endif
                if (yyssp <= yyss) goto yyabort;
                --yyssp;
                --yyvsp;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
        yychar = (-1);
        goto yyloop;
    }
yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    yyval = yyvsp[1-yym];
    switch (yyn)
    {
case 17:
#line 189 "../../dev/aic7xxx/aicasm_gram.y"
{ include_file(yyvsp[-1].str, BRACKETED_INCLUDE); }
break;
case 18:
#line 191 "../../dev/aic7xxx/aicasm_gram.y"
{ include_file(yyvsp[-1].str, QUOTED_INCLUDE); }
break;
case 19:
#line 195 "../../dev/aic7xxx/aicasm_gram.y"
{ cur_symtype = REGISTER; }
break;
case 21:
#line 200 "../../dev/aic7xxx/aicasm_gram.y"
{
			if (yyvsp[-1].sym->type != UNINITIALIZED) {
				stop("Register multiply defined", EX_DATAERR);
				/* NOTREACHED */
			}
			cur_symbol = yyvsp[-1].sym; 
			cur_symbol->type = cur_symtype;
			initialize_symbol(cur_symbol);
		}
break;
case 22:
#line 211 "../../dev/aic7xxx/aicasm_gram.y"
{                    
			/*
			 * Default to allowing everything in for registers
			 * with no bit or mask definitions.
			 */
			if (cur_symbol->info.rinfo->valid_bitmask == 0)
				cur_symbol->info.rinfo->valid_bitmask = 0xFF;

			if (cur_symbol->info.rinfo->size == 0)
				cur_symbol->info.rinfo->size = 1;

			/*
			 * This might be useful for registers too.
			 */
			if (cur_symbol->type != REGISTER) {
				if (cur_symbol->info.rinfo->address == 0)
					cur_symbol->info.rinfo->address =
					    sram_or_scb_offset;
				sram_or_scb_offset +=
				    cur_symbol->info.rinfo->size;
			}
			cur_symbol = NULL;
		}
break;
case 36:
#line 257 "../../dev/aic7xxx/aicasm_gram.y"
{
		cur_symbol->info.rinfo->address = yyvsp[0].value;
	}
break;
case 37:
#line 264 "../../dev/aic7xxx/aicasm_gram.y"
{
		cur_symbol->info.rinfo->size = yyvsp[0].value;
	}
break;
case 38:
#line 271 "../../dev/aic7xxx/aicasm_gram.y"
{
		cur_symbol->info.rinfo->mode = yyvsp[0].value;
	}
break;
case 39:
#line 278 "../../dev/aic7xxx/aicasm_gram.y"
{
		process_bitmask(BIT, yyvsp[-1].sym, yyvsp[0].value);
	}
break;
case 40:
#line 285 "../../dev/aic7xxx/aicasm_gram.y"
{
		process_bitmask(MASK, yyvsp[-1].sym, yyvsp[0].expression.value);
	}
break;
case 41:
#line 292 "../../dev/aic7xxx/aicasm_gram.y"
{
		if (yyvsp[0].sym->type != UNINITIALIZED) {
			stop("Re-definition of register alias",
			     EX_DATAERR);
			/* NOTREACHED */
		}
		yyvsp[0].sym->type = ALIAS;
		initialize_symbol(yyvsp[0].sym);
		yyvsp[0].sym->info.ainfo->parent = cur_symbol;
	}
break;
case 42:
#line 306 "../../dev/aic7xxx/aicasm_gram.y"
{
		if (accumulator != NULL) {
			stop("Only one accumulator definition allowed",
			     EX_DATAERR);
			/* NOTREACHED */
		}
		accumulator = cur_symbol;
	}
break;
case 43:
#line 318 "../../dev/aic7xxx/aicasm_gram.y"
{
		if (allones.symbol != NULL) {
			stop("Only one definition of allones allowed",
			     EX_DATAERR);
			/* NOTREACHED */
		}
		allones.symbol = cur_symbol;
	}
break;
case 44:
#line 330 "../../dev/aic7xxx/aicasm_gram.y"
{
		if (allzeros.symbol != NULL) {
			stop("Only one definition of allzeros allowed",
			     EX_DATAERR);
			/* NOTREACHED */
		}
		allzeros.symbol = cur_symbol;
	}
break;
case 45:
#line 342 "../../dev/aic7xxx/aicasm_gram.y"
{
		if (none.symbol != NULL) {
			stop("Only one definition of none allowed",
			     EX_DATAERR);
			/* NOTREACHED */
		}
		none.symbol = cur_symbol;
	}
break;
case 46:
#line 354 "../../dev/aic7xxx/aicasm_gram.y"
{
		if (sindex.symbol != NULL) {
			stop("Only one definition of sindex allowed",
			     EX_DATAERR);
			/* NOTREACHED */
		}
		sindex.symbol = cur_symbol;
	}
break;
case 47:
#line 366 "../../dev/aic7xxx/aicasm_gram.y"
{
		 yyval.expression.value = yyvsp[-2].expression.value | yyvsp[0].expression.value;
		 symlist_merge(&yyval.expression.referenced_syms,
			       &yyvsp[-2].expression.referenced_syms,
			       &yyvsp[0].expression.referenced_syms);
	}
break;
case 48:
#line 373 "../../dev/aic7xxx/aicasm_gram.y"
{
		yyval.expression.value = yyvsp[-2].expression.value & yyvsp[0].expression.value;
		symlist_merge(&yyval.expression.referenced_syms,
			       &yyvsp[-2].expression.referenced_syms,
			       &yyvsp[0].expression.referenced_syms);
	}
break;
case 49:
#line 380 "../../dev/aic7xxx/aicasm_gram.y"
{
		yyval.expression.value = yyvsp[-2].expression.value + yyvsp[0].expression.value;
		symlist_merge(&yyval.expression.referenced_syms,
			       &yyvsp[-2].expression.referenced_syms,
			       &yyvsp[0].expression.referenced_syms);
	}
break;
case 50:
#line 387 "../../dev/aic7xxx/aicasm_gram.y"
{
		yyval.expression.value = yyvsp[-2].expression.value - yyvsp[0].expression.value;
		symlist_merge(&(yyval.expression.referenced_syms),
			       &(yyvsp[-2].expression.referenced_syms),
			       &(yyvsp[0].expression.referenced_syms));
	}
break;
case 51:
#line 394 "../../dev/aic7xxx/aicasm_gram.y"
{
		yyval.expression = yyvsp[-1].expression;
	}
break;
case 52:
#line 398 "../../dev/aic7xxx/aicasm_gram.y"
{
		yyval.expression = yyvsp[0].expression;
		yyval.expression.value = (~yyval.expression.value) & 0xFF;
	}
break;
case 53:
#line 403 "../../dev/aic7xxx/aicasm_gram.y"
{
		yyval.expression = yyvsp[0].expression;
		yyval.expression.value = -yyval.expression.value;
	}
break;
case 54:
#line 408 "../../dev/aic7xxx/aicasm_gram.y"
{
		yyval.expression.value = yyvsp[0].value;
		SLIST_INIT(&yyval.expression.referenced_syms);
	}
break;
case 55:
#line 413 "../../dev/aic7xxx/aicasm_gram.y"
{
		symbol_t *symbol;

		symbol = yyvsp[0].sym;
		switch (symbol->type) {
		case ALIAS:
			symbol = yyvsp[0].sym->info.ainfo->parent;
		case REGISTER:
		case SCBLOC:
		case SRAMLOC:
			yyval.expression.value = symbol->info.rinfo->address;
			break;
		case MASK:
		case BIT:
			yyval.expression.value = symbol->info.minfo->mask;
			break;
		case DOWNLOAD_CONST:
		case CONST:
			yyval.expression.value = symbol->info.cinfo->value;
			break;
		case UNINITIALIZED:
		default:
		{
			char buf[255];

			snprintf(buf, sizeof(buf),
				 "Undefined symbol %s referenced",
				 symbol->name);
			stop(buf, EX_DATAERR);
			/* NOTREACHED */
			break;
		}
		}
		SLIST_INIT(&yyval.expression.referenced_syms);
		symlist_add(&yyval.expression.referenced_syms, symbol, SYMLIST_INSERT_HEAD);
	}
break;
case 56:
#line 453 "../../dev/aic7xxx/aicasm_gram.y"
{
		if (yyvsp[-1].sym->type != UNINITIALIZED) {
			stop("Re-definition of symbol as a constant",
			     EX_DATAERR);
			/* NOTREACHED */
		}
		yyvsp[-1].sym->type = CONST;
		initialize_symbol(yyvsp[-1].sym);
		yyvsp[-1].sym->info.cinfo->value = yyvsp[0].value;
		yyvsp[-1].sym->info.cinfo->define = yyvsp[-2].value;
	}
break;
case 57:
#line 465 "../../dev/aic7xxx/aicasm_gram.y"
{
		if (yyvsp[-2].value) {
			stop("Invalid downloaded constant declaration",
			     EX_DATAERR);
			/* NOTREACHED */
		}
		if (yyvsp[-1].sym->type != UNINITIALIZED) {
			stop("Re-definition of symbol as a downloaded constant",
			     EX_DATAERR);
			/* NOTREACHED */
		}
		yyvsp[-1].sym->type = DOWNLOAD_CONST;
		initialize_symbol(yyvsp[-1].sym);
		yyvsp[-1].sym->info.cinfo->value = download_constant_count++;
		yyvsp[-1].sym->info.cinfo->define = FALSE;
	}
break;
case 58:
#line 485 "../../dev/aic7xxx/aicasm_gram.y"
{
		yyval.value = yyvsp[0].value;
	}
break;
case 59:
#line 489 "../../dev/aic7xxx/aicasm_gram.y"
{
		yyval.value = -yyvsp[0].value;
	}
break;
case 60:
#line 496 "../../dev/aic7xxx/aicasm_gram.y"
{
			cur_symbol = symtable_get(SRAM_SYMNAME);
			cur_symtype = SRAMLOC;
			if (cur_symbol->type != UNINITIALIZED) {
				stop("Only one SRAM definition allowed",
				     EX_DATAERR);
				/* NOTREACHED */
			}
			cur_symbol->type = SRAMLOC;
			initialize_symbol(cur_symbol);
		}
break;
case 61:
#line 508 "../../dev/aic7xxx/aicasm_gram.y"
{
			sram_or_scb_offset = cur_symbol->info.rinfo->address;
		}
break;
case 62:
#line 513 "../../dev/aic7xxx/aicasm_gram.y"
{
			cur_symbol = NULL;
		}
break;
case 63:
#line 520 "../../dev/aic7xxx/aicasm_gram.y"
{
			cur_symbol = symtable_get(SCB_SYMNAME);
			cur_symtype = SCBLOC;
			if (cur_symbol->type != UNINITIALIZED) {
				stop("Only one SRAM definition allowed",
				     EX_SOFTWARE);
				/* NOTREACHED */
			}
			cur_symbol->type = SCBLOC;
			initialize_symbol(cur_symbol);
		}
break;
case 64:
#line 532 "../../dev/aic7xxx/aicasm_gram.y"
{
			sram_or_scb_offset = cur_symbol->info.rinfo->address;
		}
break;
case 65:
#line 537 "../../dev/aic7xxx/aicasm_gram.y"
{
			cur_symbol = NULL;
		}
break;
case 68:
#line 549 "../../dev/aic7xxx/aicasm_gram.y"
{
		process_register(&yyvsp[0].sym);
		yyval.sym_ref.symbol = yyvsp[0].sym;
		yyval.sym_ref.offset = 0;
	}
break;
case 69:
#line 555 "../../dev/aic7xxx/aicasm_gram.y"
{
		process_register(&yyvsp[-3].sym);
		if (yyvsp[-1].sym->type != CONST) {
			stop("register offset must be a constant", EX_DATAERR);
			/* NOTREACHED */
		}
		if ((yyvsp[-1].sym->info.cinfo->value + 1) > yyvsp[-3].sym->info.rinfo->size) {
			stop("Accessing offset beyond range of register",
			     EX_DATAERR);
			/* NOTREACHED */
		}
		yyval.sym_ref.symbol = yyvsp[-3].sym;
		yyval.sym_ref.offset = yyvsp[-1].sym->info.cinfo->value;
	}
break;
case 70:
#line 570 "../../dev/aic7xxx/aicasm_gram.y"
{
		process_register(&yyvsp[-3].sym);
		if ((yyvsp[-1].value + 1) > yyvsp[-3].sym->info.rinfo->size) {
			stop("Accessing offset beyond range of register",
			     EX_DATAERR);
			/* NOTREACHED */
		}
		yyval.sym_ref.symbol = yyvsp[-3].sym;
		yyval.sym_ref.offset = yyvsp[-1].value;
	}
break;
case 71:
#line 581 "../../dev/aic7xxx/aicasm_gram.y"
{
		if (accumulator == NULL) {
			stop("No accumulator has been defined", EX_DATAERR);
			/* NOTREACHED */
		}
		yyval.sym_ref.symbol = accumulator;
		yyval.sym_ref.offset = 0;
	}
break;
case 72:
#line 593 "../../dev/aic7xxx/aicasm_gram.y"
{
		test_writable_symbol(yyvsp[0].sym_ref.symbol);
		yyval.sym_ref = yyvsp[0].sym_ref;
	}
break;
case 73:
#line 601 "../../dev/aic7xxx/aicasm_gram.y"
{ yyval.expression = yyvsp[0].expression; }
break;
case 74:
#line 606 "../../dev/aic7xxx/aicasm_gram.y"
{
		yyval.expression = yyvsp[0].expression;
	}
break;
case 75:
#line 610 "../../dev/aic7xxx/aicasm_gram.y"
{
		SLIST_INIT(&yyval.expression.referenced_syms);
		yyval.expression.value = 0;
	}
break;
case 76:
#line 618 "../../dev/aic7xxx/aicasm_gram.y"
{
		test_readable_symbol(yyvsp[0].sym_ref.symbol);
		yyval.sym_ref = yyvsp[0].sym_ref;
	}
break;
case 77:
#line 625 "../../dev/aic7xxx/aicasm_gram.y"
{
		yyval.sym_ref.symbol = NULL;
		yyval.sym_ref.offset = 0;
	}
break;
case 78:
#line 630 "../../dev/aic7xxx/aicasm_gram.y"
{ yyval.sym_ref = yyvsp[0].sym_ref; }
break;
case 79:
#line 634 "../../dev/aic7xxx/aicasm_gram.y"
{ yyval.value = 0; }
break;
case 80:
#line 636 "../../dev/aic7xxx/aicasm_gram.y"
{ yyval.value = 1; }
break;
case 81:
#line 641 "../../dev/aic7xxx/aicasm_gram.y"
{
		if (yyvsp[-1].sym->type != UNINITIALIZED) {
			stop("Program label multiply defined", EX_DATAERR);
			/* NOTREACHED */
		}
		yyvsp[-1].sym->type = LABEL;
		initialize_symbol(yyvsp[-1].sym);
		yyvsp[-1].sym->info.linfo->address = instruction_ptr;
	}
break;
case 82:
#line 654 "../../dev/aic7xxx/aicasm_gram.y"
{
		yyval.sym_ref.symbol = yyvsp[0].sym;
		yyval.sym_ref.offset = 0;
	}
break;
case 83:
#line 659 "../../dev/aic7xxx/aicasm_gram.y"
{
		yyval.sym_ref.symbol = yyvsp[-2].sym;
		yyval.sym_ref.offset = yyvsp[0].value;
	}
break;
case 84:
#line 664 "../../dev/aic7xxx/aicasm_gram.y"
{
		yyval.sym_ref.symbol = yyvsp[-2].sym;
		yyval.sym_ref.offset = -yyvsp[0].value;
	}
break;
case 85:
#line 669 "../../dev/aic7xxx/aicasm_gram.y"
{
		yyval.sym_ref.symbol = NULL;
		yyval.sym_ref.offset = 0;
	}
break;
case 86:
#line 674 "../../dev/aic7xxx/aicasm_gram.y"
{
		yyval.sym_ref.symbol = NULL;
		yyval.sym_ref.offset = yyvsp[0].value;
	}
break;
case 87:
#line 679 "../../dev/aic7xxx/aicasm_gram.y"
{
		yyval.sym_ref.symbol = NULL;
		yyval.sym_ref.offset = -yyvsp[0].value;
	}
break;
case 88:
#line 687 "../../dev/aic7xxx/aicasm_gram.y"
{
		scope_t *new_scope;

		add_conditional(yyvsp[-1].sym);
		new_scope = scope_alloc();
		new_scope->type = SCOPE_IF;
		new_scope->begin_addr = instruction_ptr;
		new_scope->func_num = yyvsp[-1].sym->info.condinfo->func_num;
	}
break;
case 89:
#line 697 "../../dev/aic7xxx/aicasm_gram.y"
{
		scope_t *new_scope;
		scope_t *scope_context;
		scope_t *last_scope;

		/*
		 * Ensure that the previous scope is either an
		 * if or and else if.
		 */
		scope_context = SLIST_FIRST(&scope_stack);
		last_scope = TAILQ_LAST(&scope_context->inner_scope,
					scope_tailq);
		if (last_scope == NULL
		 || last_scope->type == T_ELSE) {

			stop("'else if' without leading 'if'", EX_DATAERR);
			/* NOTREACHED */
		}
		add_conditional(yyvsp[-1].sym);
		new_scope = scope_alloc();
		new_scope->type = SCOPE_ELSE_IF;
		new_scope->begin_addr = instruction_ptr;
		new_scope->func_num = yyvsp[-1].sym->info.condinfo->func_num;
	}
break;
case 90:
#line 722 "../../dev/aic7xxx/aicasm_gram.y"
{
		scope_t *new_scope;
		scope_t *scope_context;
		scope_t *last_scope;

		/*
		 * Ensure that the previous scope is either an
		 * if or and else if.
		 */
		scope_context = SLIST_FIRST(&scope_stack);
		last_scope = TAILQ_LAST(&scope_context->inner_scope,
					scope_tailq);
		if (last_scope == NULL
		 || last_scope->type == SCOPE_ELSE) {

			stop("'else' without leading 'if'", EX_DATAERR);
			/* NOTREACHED */
		}
		new_scope = scope_alloc();
		new_scope->type = SCOPE_ELSE;
		new_scope->begin_addr = instruction_ptr;
	}
break;
case 91:
#line 748 "../../dev/aic7xxx/aicasm_gram.y"
{
		scope_t *scope_context;
		scope_t *last_scope;

		scope_context = SLIST_FIRST(&scope_stack);
		if (scope_context->type == SCOPE_ROOT) {
			stop("Unexpected '}' encountered", EX_DATAERR);
			/* NOTREACHED */
		}

		scope_context->end_addr = instruction_ptr;

		/* Pop the scope */
		SLIST_REMOVE_HEAD(&scope_stack, scope_stack_links);

		process_scope(scope_context);

		if (SLIST_FIRST(&scope_stack) == NULL) {
			stop("Unexpected '}' encountered", EX_DATAERR);
			/* NOTREACHED */
		}
	}
break;
case 92:
#line 773 "../../dev/aic7xxx/aicasm_gram.y"
{ yyval.value = AIC_OP_AND; }
break;
case 93:
#line 774 "../../dev/aic7xxx/aicasm_gram.y"
{ yyval.value = AIC_OP_XOR; }
break;
case 94:
#line 775 "../../dev/aic7xxx/aicasm_gram.y"
{ yyval.value = AIC_OP_ADD; }
break;
case 95:
#line 776 "../../dev/aic7xxx/aicasm_gram.y"
{ yyval.value = AIC_OP_ADC; }
break;
case 96:
#line 781 "../../dev/aic7xxx/aicasm_gram.y"
{
		format_1_instr(yyvsp[-6].value, &yyvsp[-5].sym_ref, &yyvsp[-3].expression, &yyvsp[-2].sym_ref, yyvsp[-1].value);
	}
break;
case 97:
#line 788 "../../dev/aic7xxx/aicasm_gram.y"
{
		format_1_instr(AIC_OP_OR, &yyvsp[-5].sym_ref, &yyvsp[-3].expression, &yyvsp[-2].sym_ref, yyvsp[-1].value);
	}
break;
case 98:
#line 795 "../../dev/aic7xxx/aicasm_gram.y"
{
		expression_t immed;

		make_expression(&immed, 1);
		format_1_instr(AIC_OP_ADD, &yyvsp[-3].sym_ref, &immed, &yyvsp[-2].sym_ref, yyvsp[-1].value);
	}
break;
case 99:
#line 805 "../../dev/aic7xxx/aicasm_gram.y"
{
		expression_t immed;

		make_expression(&immed, -1);
		format_1_instr(AIC_OP_ADD, &yyvsp[-3].sym_ref, &immed, &yyvsp[-2].sym_ref, yyvsp[-1].value);
	}
break;
case 100:
#line 815 "../../dev/aic7xxx/aicasm_gram.y"
{
		expression_t immed;

		make_expression(&immed, -1);
		format_1_instr(AIC_OP_ADD, &none, &immed, &allzeros, yyvsp[-1].value);
	}
break;
case 101:
#line 822 "../../dev/aic7xxx/aicasm_gram.y"
{
		format_1_instr(AIC_OP_ADD, &yyvsp[-4].sym_ref, &yyvsp[-2].expression, &allzeros, yyvsp[-1].value);
	}
break;
case 102:
#line 829 "../../dev/aic7xxx/aicasm_gram.y"
{
		expression_t immed;

		make_expression(&immed, 1);
		format_1_instr(AIC_OP_ADD, &none, &immed, &allones, yyvsp[-1].value);
	}
break;
case 103:
#line 836 "../../dev/aic7xxx/aicasm_gram.y"
{
		expression_t immed;

		make_expression(&immed, 1);
		format_1_instr(AIC_OP_ADD, &yyvsp[-2].sym_ref, &immed, &allones, yyvsp[-1].value);
	}
break;
case 104:
#line 846 "../../dev/aic7xxx/aicasm_gram.y"
{
		format_1_instr(AIC_OP_BMOV, &yyvsp[-6].sym_ref, &yyvsp[-2].expression, &yyvsp[-4].sym_ref, yyvsp[-1].value);
	}
break;
case 105:
#line 853 "../../dev/aic7xxx/aicasm_gram.y"
{
		expression_t immed;

		make_expression(&immed, 0xff);
		format_1_instr(AIC_OP_AND, &yyvsp[-4].sym_ref, &immed, &yyvsp[-2].sym_ref, yyvsp[-1].value);
	}
break;
case 106:
#line 863 "../../dev/aic7xxx/aicasm_gram.y"
{
		format_1_instr(AIC_OP_OR, &yyvsp[-4].sym_ref, &yyvsp[-2].expression, &allzeros, yyvsp[-1].value);
	}
break;
case 107:
#line 870 "../../dev/aic7xxx/aicasm_gram.y"
{
		expression_t immed;

		make_expression(&immed, 0xff);
		format_1_instr(AIC_OP_XOR, &yyvsp[-3].sym_ref, &immed, &yyvsp[-2].sym_ref, yyvsp[-1].value);
	}
break;
case 108:
#line 880 "../../dev/aic7xxx/aicasm_gram.y"
{
		expression_t immed;

		make_expression(&immed, 0xff);
		format_1_instr(AIC_OP_AND, &yyvsp[-2].sym_ref, &immed, &allzeros, yyvsp[-1].value);
	}
break;
case 109:
#line 890 "../../dev/aic7xxx/aicasm_gram.y"
{
		expression_t immed;

		make_expression(&immed, 0xff);
		format_1_instr(AIC_OP_AND, &none, &immed, &allzeros, yyvsp[-1].value);
	}
break;
case 110:
#line 900 "../../dev/aic7xxx/aicasm_gram.y"
{
		expression_t immed;

		make_expression(&immed, 0xff);
		format_1_instr(AIC_OP_AND, &none, &immed, &allzeros, TRUE);
	}
break;
case 111:
#line 918 "../../dev/aic7xxx/aicasm_gram.y"
{ yyval.value = AIC_OP_SHL; }
break;
case 112:
#line 919 "../../dev/aic7xxx/aicasm_gram.y"
{ yyval.value = AIC_OP_SHR; }
break;
case 113:
#line 920 "../../dev/aic7xxx/aicasm_gram.y"
{ yyval.value = AIC_OP_ROL; }
break;
case 114:
#line 921 "../../dev/aic7xxx/aicasm_gram.y"
{ yyval.value = AIC_OP_ROR; }
break;
case 115:
#line 926 "../../dev/aic7xxx/aicasm_gram.y"
{
		format_2_instr(yyvsp[-6].value, &yyvsp[-5].sym_ref, &yyvsp[-3].expression, &yyvsp[-2].sym_ref, yyvsp[-1].value);
	}
break;
case 116:
#line 932 "../../dev/aic7xxx/aicasm_gram.y"
{ yyval.value = AIC_OP_JMP; }
break;
case 117:
#line 933 "../../dev/aic7xxx/aicasm_gram.y"
{ yyval.value = AIC_OP_JC; }
break;
case 118:
#line 934 "../../dev/aic7xxx/aicasm_gram.y"
{ yyval.value = AIC_OP_JNC; }
break;
case 119:
#line 935 "../../dev/aic7xxx/aicasm_gram.y"
{ yyval.value = AIC_OP_CALL; }
break;
case 120:
#line 939 "../../dev/aic7xxx/aicasm_gram.y"
{ yyval.value = AIC_OP_JZ; }
break;
case 121:
#line 940 "../../dev/aic7xxx/aicasm_gram.y"
{ yyval.value = AIC_OP_JNZ; }
break;
case 122:
#line 944 "../../dev/aic7xxx/aicasm_gram.y"
{ yyval.value = AIC_OP_JE; }
break;
case 123:
#line 945 "../../dev/aic7xxx/aicasm_gram.y"
{ yyval.value = AIC_OP_JNE; }
break;
case 124:
#line 950 "../../dev/aic7xxx/aicasm_gram.y"
{
		expression_t immed;

		make_expression(&immed, 0);
		format_3_instr(yyvsp[-2].value, &sindex, &immed, &yyvsp[-1].sym_ref);
	}
break;
case 125:
#line 960 "../../dev/aic7xxx/aicasm_gram.y"
{
		format_3_instr(yyvsp[-2].value, &yyvsp[-5].sym_ref, &yyvsp[-3].expression, &yyvsp[-1].sym_ref);
	}
break;
case 126:
#line 967 "../../dev/aic7xxx/aicasm_gram.y"
{
		format_3_instr(yyvsp[-2].value, &yyvsp[-5].sym_ref, &yyvsp[-3].expression, &yyvsp[-1].sym_ref);
	}
break;
case 127:
#line 974 "../../dev/aic7xxx/aicasm_gram.y"
{
		format_3_instr(yyvsp[-2].value, &yyvsp[-5].sym_ref, &yyvsp[-3].expression, &yyvsp[-1].sym_ref);
	}
break;
case 128:
#line 981 "../../dev/aic7xxx/aicasm_gram.y"
{
		expression_t immed;

		make_expression(&immed, 0);
		format_3_instr(yyvsp[-2].value, &yyvsp[-3].sym_ref, &immed, &yyvsp[-1].sym_ref);
	}
break;
case 129:
#line 991 "../../dev/aic7xxx/aicasm_gram.y"
{
		format_3_instr(yyvsp[-2].value, &allzeros, &yyvsp[-3].expression, &yyvsp[-1].sym_ref);
	}
break;
#line 2006 "y.tab.c"
    }
    yyssp -= yym;
    yystate = *yyssp;
    yyvsp -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        yystate = YYFINAL;
        *++yyssp = YYFINAL;
        *++yyvsp = yyval;
        if (yychar < 0)
        {
            if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *yyssp, yystate);
#endif
    if (yyssp >= yysslim && yygrowstack())
    {
        goto yyoverflow;
    }
    *++yyssp = yystate;
    *++yyvsp = yyval;
    goto yyloop;
yyoverflow:
    yyerror("yacc stack overflow");
yyabort:
    return (1);
yyaccept:
    return (0);
}
